/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Jabber
 *  Copyright (C) 1998-1999 The Jabber Team http://jabber.org/
 */

#include "etherx.h"

extern ehandler connections;
extern ehandler transports;
ehandler ehandler_list_add(ehandler list, ehandler item);
ehandler ehandler_list_isolate(ehandler list, ehandler item);
ehandler ehandler_list_free(ehandler list, ehandler item);
ehandler ehandler_list_get(ehandler list, char *host, char *namespace);

extern xmlnode config;
void config_include(xmlnode x);
void config_load(char *rfile);

void netin_onNode(thread t, xmlnode in, int type);
void netin_cleanup(void *arg);

void netout_onNode(thread t, xmlnode in, int type);
void netout_write(thread t, epacket e);
void netout_cleanup(void *arg);
void netout_error(thread t, tstream_buffer buffer);
ehandler netout_connect(char *host, char *namespace);

void manager_send(epacket e);
void manager_deliver(ehandler eh, epacket ep);
int manager_init();
int manager_init_listen(xmlnode x);
void manager_onConnect(thread t, int sock, struct sockaddr_in sa);
void manager_negotiate(thread t, xmlnode in, int type);

void transport_onNode(thread t, xmlnode in, int type); /* from socket transports */
void transport_cleanup(void *arg);

void dso_load(xmlnode x);
void *dso_open(char *so);
void *dso_sym(void *so, char *func);
void dso_transport(ehandler eh);

void logger_init();
void logger_conn(char *ns, char *from, char *to, int count);
void logger_transport(char *ns, char *from, char *id, int count);
void logger_conn2(char *ns, char *to, int count);
void logger_transport2(char *ns, char *to, char *id, int count);
