/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Jabber
 *  Copyright (C) 1998-1999 The Jabber Team http://jabber.org/
 */

#include "etherxd.h"

thread logger_device = NULL;

void logger_init()
{
    int fd;
    char *file;

    file = xmlnode_get_data(xmlnode_get_firstchild(xmlnode_get_tag(xmlnode_get_tag(config,"etherx"),"log")));

    if(file == NULL)
        return;

    log_debug(ZONE,"logger_start: %s",file);

    fd = open(file, O_WRONLY | O_CREAT | O_APPEND, 0600);
    if(file == NULL || fd < 0)
    {
        log_error("etherx","unable to open log file");
        return;
    }
 
    if(logger_device != NULL)
    {
        pth_cancel(logger_device->id); /* hmmm, does this thread get canceled before the new one starts? */
    }
 
    logger_device = tstream_new(fd,"logger",NULL,NULL,NULL);
}
 
void logger_conn(char *ns, char *from, char *to, int count)
{
    static char log[LOGSIZE_HDR];
    int size;
 
    if(logger_device == NULL)
        return;
 
    size = snprintf(log, LOGSIZE_HDR, "%s %s connection from %s to %s %d\n",
                                        create_log_timestamp(),ns,from,
                                        to, count);
    tstream_write(logger_device,log,size);
}
 
void logger_transport(char *ns, char *from, char *id, int count)
{
    static char log[LOGSIZE_HDR];
    int size;
 
    if(logger_device == NULL)
        return;
 
    size = snprintf(log, LOGSIZE_HDR, "%s %s transport from %s id %s %d\n",
                                        create_log_timestamp(),ns,from,
                                        id, count);
    tstream_write(logger_device,log,size);
}
 
void logger_conn2(char *ns, char *to, int count)
{
    static char log[LOGSIZE_HDR];
    int size;
 
    if(logger_device == NULL)
        return;
 
    size = snprintf(log, LOGSIZE_HDR, "%s %s connection to %s %d\n",create_log_timestamp(),ns,to,count);

    tstream_write(logger_device,log,size);
}
 
void logger_transport2(char *ns, char *to, char *id, int count)
{
    static char log[LOGSIZE_HDR];
    int size;
 
    if(logger_device == NULL)
        return;
 
    size = snprintf(log, LOGSIZE_HDR, "%s %s connection to %s id %s %d\n",create_log_timestamp(),ns,to,id, count);

    tstream_write(logger_device,log,size);
}
 
